import usb
import time
import pymedia
import pymedia.audio.sound as sound
import time, wave


####################################
VENDOR_RQ_SET_LED    = 0
VENDOR_RQ_GET_SWITCH_1 = 1
VENDOR_RQ_GET_SWITCH_2 = 8
VENDOR_RQ_GET_SWITCH_3 = 3
VENDOR_RQ_GET_SWITCH_4 = 4
VENDOR_RQ_GET_SWITCH_5 = 5
VENDOR_RQ_GET_SWITCH_6 = 6
VENDOR_RQ_GET_SWITCH_7 = 12
VENDOR_RQ_GET_LIGHT_1 = 2
VENDOR_RQ_GET_LIGHT_2 = 7
VENDOR_RQ_GET_LIGHT_3 = 9
VENDOR_RQ_GET_LIGHT_4 = 10
VENDOR_RQ_GET_LIGHT_5 = 11

####################################
class Board:
    def __init__(self):
        #print "Looking for MCU board..."
        dev = self.find_board()
        if not dev: raise "MCU board not found!"
        #print "MCU board found"
        self.handle = dev.open()

    def find_board(self):
        for bus in usb.busses():
            for dev in bus.devices:
                if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                    return dev
        return None

    def set_led(self,pin,val):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
        self.handle.controlMsg(reqType, VENDOR_RQ_SET_LED, None,value=val*256+pin)

    def get_switch_1(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH_1, 1)
        return buf[0]
    def get_switch_2(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH_2, 1)
        return buf[0]
    def get_switch_3(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH_3, 1)
        return buf[0]
    def get_switch_4(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH_4, 1)
        return buf[0]
    def get_switch_5(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH_5, 1)
        return buf[0]
    def get_switch_6(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH_6, 1)
        return buf[0]
    def get_switch_7(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH_7, 1)
        return buf[0]



    def get_light_1(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT_1, 2)
        return buf[0]+ buf[1]*256
    def get_light_2(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT_2, 2)
        return buf[0]+ buf[1]*256
    def get_light_3(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT_3, 2)
        return buf[0]+ buf[1]*256
    def get_light_4(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT_4, 2)
        return buf[0]+ buf[1]*256
    def get_light_5(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT_5, 2)
        return buf[0]+ buf[1]*256


